/**
 * SYS 系统设置
 * admin 系统用户
 * erp 供应链管理
 *    basic 基础信息管理
 *    bill  单据管理
 * crm crm会员管理
 * franchisee 加盟商
 * srd 店铺管理
 **/
export default [
  {
    path: '/user',
    layout: false,
    routes: [
      {
        name: '系统登录',
        path: '/user/login',
        component: './user/login',
        access: 'k1',
      },
    ],
  },
  {
    name: '系统管理',
    icon: 'SettingOutlined',
    path: '/sys',
    routes: [
      {
        name: '加盟商管理',
        icon: 'smile',
        path: '/sys/company',
        component: './sys/company',
        access: 'k2',
      },
      {
        name: '组织管理',
        icon: 'smile',
        path: '/sys/org',
        component: './sys/org',
        access: 'k2',
      },
      {
        name: '操作日志',
        icon: 'smile',
        path: '/sys/log',
        component: './sys/log',
        access: 'k3',
      },
      {
        name: '系统用户',
        icon: 'smile',
        path: '/sys/user',
        component: './sys/user',
        access: 'k4',
      },
      {
        name: '角色权限',
        icon: 'smile',
        path: '/sys/roles',
        component: './sys/roles',
        access: 'k5',
      },
      {
        name: '系统菜单',
        icon: 'smile',
        path: '/sys/menus',
        component: './sys/menus',
        access: 'k6',
      },
      {
        name: '字典信息',
        icon: 'smile',
        path: '/sys/dictionary/dictdata',
        component: './sys/dictionary/dictdata',
        access: 'k6',
      },
      {
        name: '字典类型',
        icon: 'smile',
        path: '/sys/dictionary/dicttype',
        component: './sys/dictionary/dicttype',
        access: 'k6',
      },
      {
        name: '系统配置',
        icon: 'smile',
        path: '/sys/sysSettings',
        component: './sys/sysSettings',
        access: 'k6',
      },
      {
        name: '设备管理',
        icon: 'smile',
        path: '/sys/storemanage',
        component: './sys/storemanage',
        access: 'k6',
      },
    ],
  },
  {
    name: '物料管理',
    icon: 'DropboxSquareFilled',
    path: '/erp',
    routes: [
      {
        name: '物料信息',
        icon: 'smile',
        path: '/erp/basic/product',
        component: './erp/basic/product',
        access: 'k7',
      },
      {
        name: '物料单位',
        icon: 'smile',
        path: '/erp/basic/unit',
        component: './erp/basic/unit',
        access: 'k8',
      },
      {
        name: '物料分类',
        icon: 'smile',
        path: '/erp/basic/productType',
        component: './erp/basic/productType',
        access: 'k9',
      },
      {
        name: '验收入库',
        icon: 'smile',
        path: '/erp/bill/receivingNote',
        component: './erp/bill/receivingNote',
        access: 'k15',
      },
      {
        name: '采购管理',
        icon: 'smile',
        path: '/erp/bill/purchaseOrder',
        component: './erp/bill/purchaseOrder',
      },
      {
        name: '物料库存',
        icon: 'smile',
        path: '/erp/stock',
        component: './erp/stock',
        access: 'k16',
      },
    ],
  },
  {
    name: '物料管理',
    icon: 'DropboxSquareFilled',
    path: '/bom',
    routes: [
      {
        name: '配方管理',
        icon: 'smile',
        path: '/bom/manage',
        component: './bom/manage',
        access: 'k7',
      },
      {
        name: '配方分类',
        icon: 'smile',
        path: '/bom/bomtype',
        component: './bom/bomtype',
        access: 'k7',
      },
      {
        name: '配方下发',
        icon: 'smile',
        path: '/bom/push',
        component: './bom/push',
        access: 'k8',
      },
    ],
  },
  {
    name: '商品管理',
    icon: 'ProjectFilled',
    path: '/goods',
    routes: [
      {
        name: '商品管理',
        icon: 'smile',
        path: '/goods/goods-manage',
        component: './goods/goods-manage',
        access: 'k10',
      },
      {
        name: '商品管理新',
        icon: 'smile',
        path: '/goods/newgoods',
        component: './goods/newgoods',
        access: 'k10',
      },
      {
        name: '商品口味',
        icon: 'smile',
        path: '/goods/goods-taste',
        component: './goods/goods-taste',
        access: 'k11',
      },
      {
        name: '商品小类',
        icon: 'smile',
        path: '/goods/goods-type-manage',
        component: './goods/goods-type-manage',
        access: 'k11',
      },
      {
        name: '商品大类',
        icon: 'smile',
        path: '/goods/goodsParentTypemanage',
        component: './goods/goodsParentTypemanage',
        access: 'k11',
      },
      {
        name: '商品单位',
        icon: 'smile',
        path: '/goods/unit',
        component: './goods/unit',
        access: 'k11',
      },
      {
        name: '商品详情',
        icon: 'smile',
        path: '/goods/goodsInfo',
        component: './goods/goodsInfo',
        access: 'k11',
      },
      {
        name: '商品做法',
        icon: 'smile',
        path: '/goods/goodsPractice',
        component: './goods/goodsPractice',
        access: 'k9',
      },
      {
        name: '商品做法类别',
        icon: 'smile',
        path: '/goods/goodsPracticeType',
        component: './goods/goodsPracticeType',
        access: 'k9',
      },
      {
        name: '商品做法基础信息',
        icon: 'smile',
        path: '/goods/goodsPracticeInfo',
        component: './goods/goodsPracticeInfo',
        access: 'k9',
      },


    ],
  },

  {
    name: '店铺管理',
    icon: 'BankFilled',
    path: '/store',
    routes: [
      {
        name: '店铺类型',
        icon: 'smile',
        path: '/store/storeType',
        component: './store/storeType',
        access: 'k12',
      },
      {
        name: '店铺小票打印机',
        icon: 'smile',
        path: '/store/printer/Printer',
        component: './store/printer/Printer',
        access: 'k12',
      },
      {
        name: '打印机模板',
        icon: 'smile',
        path: '/store/printer/printerTemplate',
        component: './store/printer/printerTemplate',
        access: 'k12',
      },

      {
        name: '店铺桌面码',
        icon: 'smile',
        path: '/store/storeDesktopNumber',
        component: './store/storeDesktopNumber',
        access: 'k12',
      },
      {
        name: '店铺等级',
        icon: 'smile',
        path: '/store/storeLevel',
        component: './store/storeLevel',
        access: 'k13',
      },
      {
        name: '店铺信息',
        icon: 'smile',
        path: '/store/storeInfo',
        component: './store/storeInfo',
        access: 'k14',
      },
      {
        name: '加购商品',
        icon: 'smile',
        path: '/store/storeAddGoodsInfo',
        component: './store/storeAddGoodsInfo',
        access: 'k14',
      },
      {
        name: '店铺商品',
        icon: 'smile',
        path: '/store/storeGoodsInfo',
        component: './store/storeGoodsInfo',
        access: 'k14',
      },
      {
        name: '店铺广告',
        icon: 'smile',
        path: '/store/storeAdvertisement',
        component: './store/storeAdvertisement',
        access: 'k39',
      },
    ],
  },
  {
    name: '设备管理',
    icon: 'BankFilled',
    path: '/device',
    routes: [
      {
        name: '设备分类',
        icon: 'smile',
        path: '/device/deviceType',
        component: './device/deviceType',
        access: 'k12',
      },
      {
        name: '设备信息',
        icon: 'smile',
        path: '/device/deviceInfo',
        component: './device/deviceInfo',
        access: 'k14',
      },
      {
        name: '设备商品管理',
        icon: 'smile',
        path: '/device/deviceFood',
        component: './device/deviceFood',
        access: 'k14',
      },
      {
        code: 'deviceBOM',
        name: '设备配方管理',
        icon: 'smile',
        path: '/device/deviceBom',
        component: './device/deviceBom',
        access: 'k14',
      },
      {
        name: '设备补货',
        icon: 'smile',
        path: '/device/deviceStock',
        component: './device/deviceStock',
        access: 'k14',
      },
      {
        name: '设备配方补货',
        icon: 'smile',
        path: '/device/deviceRecipeStock',
        component: './device/deviceRecipeStock',
        access: 'k14',
      }

    ],
  },
  {
    name: '积分管理',
    icon: 'BankFilled',
    path: '/integral',
    routes: [
      {
        name: '积分规则',
        icon: 'smile',
        path: '/integral/integralConfigure',
        component: './integral/integralConfigure',
        access: 'k12',
      },
      {
        name: '规则分发',
        icon: 'smile',
        path: '/integral/integralDistribute',
        component: './integral/integralDistribute',
        access: 'k12',
      },
    ]
  },
  {
    name: '菜谱管理',
    icon: 'BankFilled',
    path: '/foodMenu',
    routes: [
      {
        name: '菜谱设置',
        icon: 'smile',
        path: '/foodMenu/foodMenuInfo',
        component: './foodMenu/foodMenuInfo',
        access: 'k12',
      },
      {
        name: '菜谱关联门店',
        icon: 'smile',
        path: '/foodMenu/storeFoodMenu',
        component: './foodMenu/storeFoodMenu',
        access: 'k14',
      },
      {
        name: '菜谱关联菜品',
        icon: 'smile',
        path: '/foodMenu/foodMenu',
        component: './foodMenu/foodMenu',
        access: 'k14',
      }
    ]
  },
  {
    name: '会员管理',
    icon: 'UserSwitchOutlined',
    path: '/member',
    routes: [
      {
        name: '会员信息',
        icon: 'smile',
        path: '/member/memberInfo',
        component: './member/memberInfo',
        access: 'k17',
      },
      {
        name: '会员标签信息',
        icon: 'smile',
        path: '/member/membertag',
        component: './member/membertag',
        access: 'k18',
      },
      {
        name: '会员数据分析',
        icon: 'smile',
        path: '/member/memberAnalysis',
        component: './member/memberAnalysis',
        access: 'k19',
      },
    ],
  },
  {
    name: '活动管理',
    icon: 'CarryOutOutlined',
    path: '/activity',
    routes: [
      {
        name: '活动信息',
        icon: 'smile',
        path: '/activity/activityInfo',
        component: './activity/activityInfo',
        access: 'k20',
      },
      {
        name: '活动记录信息',
        icon: 'smile',
        path: '/activity/activityRecord',
        component: './activity/activityRecord',
        access: 'k21',
      },
    ],
  },
  {
    name: '优惠券管理',
    icon: 'WalletOutlined',
    path: '/crm',
    routes: [
      {
        name: '优惠卷管理',
        icon: 'smile',
        path: '/crm/coupon/couponInfo',
        component: './crm/coupon/couponInfo',
        access: 'k22',
      },
      {
        name: '优惠卷批次信息',
        icon: 'smile',
        path: '/crm/coupon/coupon-Batch',
        component: './crm/coupon/coupon-Batch',
        access: 'k23',
      },
      {
        name: '优惠卷领取信息',
        icon: 'smile',
        path: '/crm/coupon/customerCoupon',
        component: './crm/coupon/customerCoupon',
        access: 'k24',
      },
    ],
  },
  {
    name: '分账管理',
    icon: 'RedEnvelopeOutlined',
    path: '/split',
    routes: [
      {
        name: '分账账户管理',
        icon: 'smile',
        path: '/split/account',
        component: './split/account',
        access: 'k25',
      },
      {
        name: '加盟商分账方案',
        icon: 'smile',
        path: '/split/FranchiseePlan',
        component: './split/FranchiseePlan',
        access: 'k25',
      },
      {
        name: '分账方案管理',
        icon: 'smile',
        path: '/split/plan',
        component: './split/plan',
        access: 'k26',
      },
      {
        name: '分账订单管理',
        icon: 'smile',
        path: '/split/splitOrders',
        component: './split/splitOrders',
        access: 'k27',
      },
    ],
  },
  {
    name: '退款操作',
    icon: 'AccountBookOutlined',
    path: '/refundment',
    routes: [
      {
        name: '售后申请',
        icon: 'smile',
        path: '/refundment/orderAfterSales',
        component: './refundment/orderAfterSales',
        access: 'k28',
      },
    ],
  },
  {
    name: '报表统计',
    icon: 'SmileOutlined',
    path: '/order',
    routes: [
      {
        name: '订单汇总',
        path: '/order/order-summary-manage',
        component: './order/order-summary-manage',
        access: 'k29',
      },
      {
        name: '订单流水',
        path: '/order/order-flow-manage',
        component: './order/order-flow-manage',
        access: 'k30',
      },
      {
        name: '订单明细',
        path: '/order/orderDetail',
        component: './order/orderDetail',
        access: 'k31',
      },
      {
        name: '营业日报',
        path: '/order/ordersalescountbyday',
        component: './order/ordersalescountbyday',
        access: 'k32',
      },
      {
        name: '异常订单信息',
        path: '/order/exOrder',
        component: './order/exOrder',
        access: 'k31',
      },
      {
        name: '营收报表',
        path: '/order/order-market-report',
        component: './order/order-market-report',
        access: 'k31',
      },
      {
        name: '订单报表',
        path: '/order/order-report',
        component: './order/order-report',
        access: 'k31',
      },
      {
        name: '订单报表详情',
        path: '/order/order-report/order-report-detail',
        component: './order/order-report-detail',
        access: 'k31',
      },
      {
        name: '营销报表',
        path: '/order/order-revenue-statement',
        component: './order/order-revenue-statement',
        access: 'k31',
      },
      {
        name: '产品报表',
        path: '/order/order-product-report',
        component: './order/order-product-report',
        access: 'k31',
      },
      {
        name: '会员报表',
        path: '/order/order-member-statement',
        component: './order/order-member-statement',
        access: 'k31',
      },
      {
        name: '销售成本分析',
        path: '/order/cost-of-sales',
        component: './order/cost-of-sales',
        access: 'k31',
      },
      {
        name: '销售毛利分析',
        path: '/order/sales-gross-profit',
        component: './order/sales-gross-profit',
        access: 'k31',
      },
      {
        name: '门店销售毛利分析',
        path: '/order/gross-profit-store-sales',
        component: './order/gross-profit-store-sales',
        access: 'k31',
      },
    ],
  },
  {
    name: '库存管理',
    icon: 'HddOutlined',
    path: '/stockManager',
    routes: [
      {
        name: '其它物料入库',
        path: '/stockManager/stockItem',
        component: './stockManager/stockItem',
        access: 'k36',
      },
      {
        name: '库存盘点',
        path: '/stockManager/stockInventory',
        component: './stockManager/stockInventory',
        access: 'k37',
      },
      {
        name: '库存报表',
        path: '/stockManager/stockReports',
        component: './stockManager/stockReports',
        access: 'k38',
      },
    ],
  },
  {
    name: '财务报表',
    icon: 'HddOutlined',
    path: '/financereport',
    routes: [
      {
        name: '财务账单',
        path: '/financereport/finance',
        component: './financereport/finance',
        access: 'k37',
      },
    ],
  },
  {
    path: '/',
    redirect: '/welcome',
  },
  {
    path: '/welcome',
    name: 'welcome',
    icon: 'smile',
    component: './Welcome',
  },
  {
    name: 'test',
    icon: 'HddOutlined',
    path: '/test',
    routes: [
      {
        name: 'test',
        path: '/test/update',
        component: './test/update',
        access: 'k37',
      },
      {
        name: 'test',
        path: '/test',
        component: './test',
        access: 'k37',
      },
    ],
  },
  //什么都不要想404直接放最后
  {
    component: './404',
  },
];
