import { DropboxOutlined, PlusOutlined, DownloadOutlined } from '@ant-design/icons';
import { Button, message, Select, Input, Drawer } from 'antd';
import React, { useState, useRef, useEffect } from 'react';
import { PageContainer, FooterToolbar } from '@ant-design/pro-layout';
import ProTable from '@ant-design/pro-table';
import ProDescriptions from '@ant-design/pro-descriptions';
import ExportJsonExcel from 'js-export-excel';
import api from './service';

//页面 相当于 class
const Manage = () => {
  //获取店铺类型(店铺类型)
  const [srdTypeList, setsrdTypeList] = useState([]);
  //获得店铺名称(店铺名称)
  const [srdList, setsrdList] = useState([]);
  //商品名称
  const [goodList, setgoodList] = useState([]);
  // //加盟商
  // const [franchList, setfranchList] = useState([]);
  //商品类型
  const [goodsTypeList, setgoodsTypeList] = useState([]);
  const [dataList, setdataList] = useState([]);
  //绑定
  const actionRef = useRef();
  // 获取店铺分类、商品名称信息
  useEffect(() => {
    // //加盟商
    // function initfranchList() {
    //   api.franchList({ current: 1, pageSize: 20, status: '0' }).then((r) => {
    //     var arr2 = r.data.data;
    //     arr2.forEach((element) => {
    //       element.text = element.name;
    //       element.franchiseeId = element.id;
    //     });
    //     setfranchList(arr2);
    //   });
    // }
    //店铺分类（店铺类型）
    function initsrdTypeList() {
      api.srdTypeList().then((r) => {
        var arr = r.data;
        arr.forEach((element) => {
          element.storeTypeId = element.id;
          element.text = element.name;
        });
        setsrdTypeList(arr);
      });
    }
    //店铺名称（店铺信息）
    function initsrdList() {
      api.srdList().then((r) => {
        var arr = r.data;
        arr.forEach((element) => {
          element.value = element.id;
          element.label = element.name;
        });
        setsrdList(arr);
      });
    }
    //商品信息
    function initgoodsList() {
      api.goodsList().then((r) => {
        var arr1 = r.data;
        arr1.forEach((element) => {
          element.label = element.name;
          element.value = element.id;
        });
        setgoodList(arr1);
      });
    }

    //查询商品类型
    function initgoodsTypeList() {
      api.goodsTypeList().then((r) => {
        var arr2 = r.data;
        arr2.forEach((element) => {
          element.label = element.name;
          element.value = element.id;
        });
        setgoodsTypeList(arr2);
      });
    }
    //initfranchList();
    initsrdList();
    initsrdTypeList();
    initgoodsList();
    initgoodsTypeList();
  }, []);
  function handleExport() {
    const { ReqDetailList } = dataList; // 网络请求命名空间
    const option = {};
    var Excelcolumns = [];
    columns.map((item, index) => {
      if (index > 5) {
        Excelcolumns.push(item);
      }
    });
    option.fileName = '订单汇总';
    option.datas = [
      {
        sheetData: dataList.map((item) => {
          const result = {};
          columns.forEach((c, index) => {
            if (index > 5) {
              result[c.dataIndex] = item[c.dataIndex];
            }
          });
          return result;
        }),
        sheetName: '订单汇总', // Excel文件名称
        sheetFilter: Excelcolumns.map((item) => item.dataIndex),
        sheetHeader: Excelcolumns.map((item) => item.title),
        columnWidths: Excelcolumns.map(() => 10),
      },
    ];

    const toExcel = new ExportJsonExcel(option);
    toExcel.saveExcel();
  }
  /** 国际化配置 */

  const columns = [
    {
      title: '主键',
      dataIndex: 'id',
      tip: '规则名称是唯一的 key',
      hideInSearch: true,
      hideInTable: true,
    },
    // {
    //   title: '加盟商',
    //   dataIndex: 'franchiseeId',
    //   hideInTable: true,
    //   valueType: 'select',
    //   valueEnum: franchList,
    // },
    // {
    //   title: '加盟商',
    //   dataIndex: 'franchiseeName',
    //   hideInSearch: true,
    // },
    {
      title: '店铺分类',
      dataIndex: 'storeTypeId',
      hideInTable: true,
      valueType: 'select',
      valueEnum: srdTypeList,
      fixed: 'left',
      width: 120,
    },
    {
      title: '订单时间',
      dataIndex: 'order_CreateTime',
      valueType: 'dateRange',
      width: 120,
      hideInTable: true,
      search: {
        transform: (value) => {
          return {
            order_CreateTime: value[0],
            order_EndTime: value[1],
          };
        },
      },
    },
    {
      title: '店铺名称',
      dataIndex: 'storeId',
      hideInTable: true,
      fixed: 'left',
      width: 120,
      renderFormItem: () => (
        <Select
          mode="multiple"
          showArrow
          placeholder="请选择店铺"
          style={{ width: '100%' }}
          options={srdList}
        />
      ),
    },
    {
      title: '商品类型',
      dataIndex: 'goodsTypeId',
      hideInTable: true,
      valueType: 'select',
      fixed: 'left',
      width: 120,
      renderFormItem: () => (
        <Select
          mode="multiple"
          showArrow
          placeholder="请选择商品类型"
          style={{ width: '100%' }}
          options={goodsTypeList}
        />
      ),
    },
    {
      title: '商品名称',
      dataIndex: 'goodsId',
      hideInTable: true,
      valueType: 'select',
      fixed: 'left',
      width: 120,
      renderFormItem: () => (
        <Select
          mode="multiple"
          showArrow
          optionFilterProp="label"
          placeholder="请选择商品"
          style={{ width: '100%' }}
          options={goodList}
        />
      ),
    },
    {
      title: '店铺分类',
      dataIndex: 'storeTypeName',
      hideInSearch: true,
      fixed: 'left',
      width: 120,
    },

    {
      title: '店铺名称',
      dataIndex: 'storeName',
      hideInSearch: true,
      fixed: 'left',
      width: 120,
    },

    {
      title: '商品类型',
      dataIndex: 'goodsTypeName',
      hideInSearch: true,
      fixed: 'left',
      width: 120,
    },

    {
      title: '商品名称',
      dataIndex: 'goodsName',
      hideInSearch: true,
      fixed: 'left',
      width: 120,
    },
    {
      title: '应付款金额',
      dataIndex: 'order_OriginalMoney',
      renderText: (val) => `${val}¥`,
      hideInSearch: true,
      fixed: 'left',
      width: 160,
    },
    {
      title: '实际付款金额',
      dataIndex: 'order_RealMoney',
      hideInSearch: true,
      renderText: (val) => `${val}¥`,
      fixed: 'left',
      width: 160,
    },
    {
      title: '退款金额',
      dataIndex: 'refundMoney',
      hideInSearch: true,
      renderText: (val) => `${val}¥`,
      fixed: 'left',
      width: 120,
    },
    {
      title: '总订单',
      dataIndex: 'sumOrder',
      hideInSearch: true,
      fixed: 'left',
      width: 120,
    },
    {
      title: '下单总碗数(碗)',
      dataIndex: 'countDetail',
      hideInSearch: true,
      fixed: 'left',
      width: 160,
    },
    {
      title: '退款订单',
      dataIndex: 'refund',
      hideInSearch: true,
      fixed: 'left',
      width: 120,
    },
    {
      title: '退款碗数(碗)',
      dataIndex: 'refundNum',
      hideInSearch: true,
      fixed: 'left',
      width: 120,
    },
    {
      title: '正常订单(碗)',
      dataIndex: 'orderNum',
      hideInSearch: true,
      width: 120,
    },
    {
      title: '盲盒订单(碗)',
      dataIndex: 'boxNum',
      hideInSearch: true,
      width: 120,
    },
    {
      title: '立即吃面订单(碗)',
      dataIndex: 'nowNum',
      hideInSearch: true,
      width: 160,
    },
    {
      title: '废弃订单(碗)',
      dataIndex: 'abandoned',
      hideInSearch: true,
      width: 120,
    },
    {
      title: '下单总人数',
      dataIndex: 'customer',
      hideInSearch: true,
      width: 120,
    },
  ];

  return (
    <PageContainer>
      <ProTable
        headerTitle="订单汇总查询"
        actionRef={actionRef}
        rowKey="id"
        scroll={{ x: 1300 }}
        search={{
          labelWidth: 120,
        }}
        toolBarRender={() => [
          <Button type="primary" key="create" onClick={() => handleExport()}>
            <DownloadOutlined /> 导出
          </Button>,
        ]}
        columns={columns}
        //数据绑定
        request={async (params, sorter, filter) => {
          var orderSummayData = [];
          var total = 0;
          // if (params.franchiseeId != null) {
          //   //加盟商
          //   params.franchiseeId = franchList[params.franchiseeId].franchiseeId;
          // }
          if (params.storeTypeId != undefined) {
            //店铺分类
            params.storeTypeId = srdTypeList[params.storeTypeId].storeTypeId;
          }
          // if (params.storeId != undefined) {
          //   //店铺名称
          //   params.storeId = srdList[params.storeId].storeId;
          // }
          // if (params.goodsId != undefined) {
          //   //商品名称
          //   params.goodsId = goodList[params.goodsId].goodsId;
          // }
          // if (params.goodsTypeId) {
          //   //商品类型
          //   params.goodsTypeId = goodsTypeList[params.goodsTypeId].goodsTypeId;
          // }
          // 表单搜索项会从 params 传入，传递给后端接口。
          //const msg = await api.orderSummaryList(params);
          await api.orderSummaryList(params).then((r) => {
            orderSummayData = r.data.data;
            total = r.data.total;
            setdataList(r.data.data);
          });
          return {
            data: orderSummayData,
            // success 请返回 true，
            // 不然 table 会停止解析数据，即使有数据
            success: true,
            // 不传会使用 data 的长度，如果是分页一定要传
            total: total,
          };
        }}
      ></ProTable>
    </PageContainer>
  );
};

export default Manage;
